/*
 * Copyright (c) 2001 The Anthill Team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package anthill.storage.impl;

import anthill.Resource;
import anthill.factory.Factory;
import anthill.storage.QueryController;

/**
 *  <code>ExactQueryController</code> to match only exact queries
 *  against a given resource.
 *
 *  @author Hein Meling
 *  @version $Revision: 1.3 $
 */
public class ExactQueryController
implements QueryController
{
  ////////////////////////////////////////////////////////////////////////////////////////////
  // Constructor
  ////////////////////////////////////////////////////////////////////////////////////////////

  /**
   *  Constructor for the query controller
   *
   *  @param factory the factory to be used to read configuration arguments
   *    and to create other configurable objects
   *  @param name the name that is associated to this instance in the
   *    configuration file
   */
  public ExactQueryController(Factory factory, String name)
  {
  }


  /**
   *  Returns true if the given resource and query are exact matches;
   *  otherwise false is returned.
   */
  public boolean satisfies(Resource resource, Object query)
  {
    if (query.equals(resource.getName()))
      return true;
    return false;
  }

} // END ExactQueryController
