/*
 * Copyright (c) 2001 The Anthill Team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package ants.freeant;

import java.io.IOException;

import anthill.types.URLResource;

/**
 *  A request object for inserting a document reference into a
 *  peer network.
 *
 *  @author Hein Meling
 *  @version $Revision: 1.2 $
 */
class InsertRequest
{

  ////////////////////////////////////////////////////////////////////////////////////////////
  // Fields
  ////////////////////////////////////////////////////////////////////////////////////////////
  
  /** The <CODE>URLResource</CODE> associated to the document to be inserted */
  URLResource resource;

  /** A set of blank-separated keywords enclosed in a string */
  String keywords;

  
  ////////////////////////////////////////////////////////////////////////////////////////////
  // Constructors
  ////////////////////////////////////////////////////////////////////////////////////////////

  /**
   *  Creates an InsertRequest object for the specified URL.
   *  
   *  @param resource the URLResource associated  to the document to be inserted
   *  @param keywords the set of keywords to be associated to the document 
   */
  InsertRequest(URLResource resource, String keywords)
    throws IOException
  {
    this.resource = resource;
    this.keywords = keywords;
  }

} // END InsertRequest


