/******************************************************
 * File: InsantRequest.java
 * created 09-Apr-02 9:11:48 AM by root
 */

package ants.utils;

import java.io.IOException;
import java.net.URL;

/**
*  This is the class representing the request a nest implementation has to pass the
*  ant in charge of spreading the knowledge about the existence of a new resource.
*  Every ant meant for this task has to accept such a request as input parameter, or 
*  a class extending ants.utils.InsantRequest. 
*
*  @author Francesco Russo (frusso@cs.unibo.it)
*/
public class InsantRequest
{
  /** A url reference to the document being inserted. */
  UrlResource urlResource;

  /** A keyword string associated with this document. */
  String keywords;

  ////////////////////////////////////////////////////////////////////////////////////////////
  // Constructors
  ////////////////////////////////////////////////////////////////////////////////////////////

  /**
   *  Creates an InsantRequest object for the specified URL.
   *  This constructor computes keywords based on the filename
   *  supplied with the URL.
   */
  public InsantRequest(URL url, String keywords)
  throws IOException
  {
	this.keywords = keywords;
	urlResource = new UrlResource(url);
  }

  /**
   *  Creates an InsantRequest object for the specified URL.
   *  This constructor computes keywords based on the filename
   *  supplied with the URL.
   *
   *  SIMULATION VERSION.
   */
  public InsantRequest(String urlString, String keywords)
  {
	this.keywords = keywords;
	urlResource = new UrlResource(urlString);
  }
  
  public UrlResource getUrlResource()
  {
	return urlResource;
  }
  
  public String getKeywords()
  {
	return keywords;
  }
}
