/*
 * Copyright (c) 2001 The Anthill Team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package antsim;

import java.util.List;

import anthill.util.Clearable;

/**
 *  Interface <CODE>ResourceSet</CODE> is used in scenarios in order to
 *  obtain a set of resources to be inserted in the simulated peer network 
 *  and a set of requests to be performed. 
 *  
 *  @author Alberto Montresor
 *  @version $Revision: 1.2 $
 */
public interface ResourceSet
extends Clearable
{

  ////////////////////////////////////////////////////////////////////////////////////////////
  // Constants
  ////////////////////////////////////////////////////////////////////////////////////////////
  
  /** Identifier used in the configuration files */
  public static final String NAME = "ResourceSet";

  
  ////////////////////////////////////////////////////////////////////////////////////////////
  // Methods
  ////////////////////////////////////////////////////////////////////////////////////////////

  /**
   *  Returns a list containing the resources contained in this
   *  resource set. Returns null if the list is empty.
   */
  public List getResources();
  

} // END ResourceSet

