/*
 * Copyright (c) 2001 The Anthill Team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package antsim;

import anthill.RequestId;
import anthill.nest.ResponseListener;
import anthill.util.Clearable;


/**
 *  Interface <CODE>ResponseMonitor</CODE>
 *  
 *  @author Hein Meling
 *  @version $Revision: 1.5 $
 */
public interface ResponseMonitor
extends Clearable, ResponseListener
{

  ////////////////////////////////////////////////////////////////////////////////////////////
  // Constants
  ////////////////////////////////////////////////////////////////////////////////////////////

  /** Identifier used in the configuration files */
  public static final String NAME = "ResponseMonitor";


  ////////////////////////////////////////////////////////////////////////////////////////////
  // Interface methods 
  ////////////////////////////////////////////////////////////////////////////////////////////

  /**
   *  
   */
  public void setStatistics(Stats stats);


  /**
   *  
   */
  public void tick();


  /**
   *  
   */
  public void tick(int v);


  /**
   *  Must be invoked prior to invoking a request on a nest, to ensure
   *  that the given request is stored to enable lookup on responses.
   */
  public void startRequest(RequestId rid);


} // END ResponseMonitor
