/* Generated by Together */

package jxtaimpl;
import java.util.Hashtable;

import anthill.Resource;
import anthill.nest.ResponseListener;

/**
 * This class maps RequestIds to appropriate ResponseListeners
 * @author Francesco Russo (frusso@cs.unibo.it) 
 * @stereotype implementationClass
 */
public class RequestSet implements anthill.nest.RequestSet 
{
  /**
  * This is the default constructor
  */
  public RequestSet() 
  {
	hTab = new Hashtable();
  }

  /**
  * Add a new entry 
  */
  public synchronized void add(anthill.RequestId rId, anthill.nest.ResponseListener rLstn) 
  {
	try
	{
	  hTab.put( ((jxtaimpl.ids.RequestId) rId).getId(), rLstn );
	  System.out.println("--- RequestSet: add - added id "+((jxtaimpl.ids.RequestId) rId).getId());
	}
	catch(NullPointerException npe)
	{
	  npe.printStackTrace();
	}
  }

  /**
  * Return the specified array of resources to the listener associated with the given RequestId  
  */
  public synchronized boolean returnResources(anthill.RequestId rId, Resource[] res) 
  {
	ResponseListener listener = (ResponseListener) hTab.get( ((jxtaimpl.ids.RequestId) rId).getId() );    
	System.out.println("--- RequestSet: returnResources() removing id "+((jxtaimpl.ids.RequestId) rId).getId());
	if (listener != null) 
	{
	  try
	  {
		  listener.returnResources(rId, res);
		  System.out.println("--- RequestSet: returnResources() TRUE -> listener reached!");
		  return true;
	  }
	  catch(Exception e)
	  {
		hTab.remove( ((jxtaimpl.ids.RequestId) rId).getId() );    
		System.out.println("--- RequestSet: returnResources() Exception -> listener not reached!");
		return false;
	  }
	}
	System.out.println("--- RequestSet: returnResources() FALSE -> listener not reached!");
	return false;
  }
  
  /**
  * Bring this object's initial state back
  */
  public synchronized void clear()
  {
	hTab.clear();
  }
  
  private Hashtable hTab;
}
