/******************************************************
 * File: SpeciesNotFoundException.java
 * created 02-Feb-02 7:45:35 PM by frusso@cs.unibo.it
 */


package jxtaimpl;

/**
*  This class is used for throwing an exception whenever a wrong ant
*  species is used. A wrong ant species is an ant species which does
*  not appear in the XML document called "jxtaimpl.xml" which is in 
*  the "config" directory of the jxtaDist distribution. 
* @stereotype exception
*/
public class SpeciesNotFoundException extends Exception
{
  private String species;

  /**
  * The <CODE>String</CODE> passed to the constructor is the ant
  * species unknown to this Nest.
  */
  public SpeciesNotFoundException(String species)
  {
    super();
    this.species = species;
  }
  
  /**
  * Returns the ant species which caused this exception.
  */
  public String getSpecies()
  {
    return species;
  }
}
