/******************************************************
 * File: LocalStorageView.java
 * created 29-Jan-02 4:31:25 PM by root
 */


package jxtaimpl.gui;
import java.awt.event.*;

import javax.swing.*;
import jxtaimpl.storage.AnthillResource;

public class LocalStorageView extends JFrame
{
  private AnthillResource[] resources;
  private JTable table;
  private JScrollPane scroll;
  
  public LocalStorageView(AnthillResource[] res)
  {
    resources = res;
    
    setTitle("Anthill&Jxta: Local Resources");
    setSize( 500, 300 );
    setResizable( true );
    addWindowListener( new WindowAdapter()
                      {
                public void windowClosing( WindowEvent e)
                {
                  dispose();
                }
             }
            );
    table = new JTable( res.length+1, 4 );
    table.setValueAt( " NAME", 0, 0);
    table.setValueAt( " TYPE", 0, 1);
    table.setValueAt( " LENGTH (bytes)", 0, 2);
    table.setValueAt( " DESCRIPTION", 0, 3);
    for(int i=0; i<res.length; i++)
    {
      table.setValueAt( res[i].getResourceName(), i+1, 0);
      table.setValueAt( res[i].getAttribute("type"), i+1, 1);
      table.setValueAt( new Long(res[i].getContentLength()), i+1, 2);
      table.setValueAt( res[i].getAttribute("description"), i+1, 3);
    }
    scroll = new JScrollPane( table );
    getContentPane().add( scroll );
  }
  
  
}
