/* Generated by Together */

package jxtaimpl.ids;

import java.io.Serializable;
import java.net.*;

import net.jxta.document.AdvertisementFactory;
import net.jxta.id.IDFactory;
import net.jxta.protocol.PipeAdvertisement;

/**
 * The class NestId uses a gateService-PipeAdv in order to identify a nest
 * @author Francesco Russo (frusso@cs.unibo.it) 
 */
public class NestId implements anthill.NestId, Serializable 
{
  //PipeAdvertisement pipeAdv = null;
  private String name;
  private String type;
  private URL id;

  /**
  * The constructor takes as input value the pipe adv of this nest's GateService instance.
  * That's the smallest information we need in order to get in touch with other nests
  *
  * @paran pipeAdvertisement The nest's GateService inputPipe advertisement
  */
  public NestId(PipeAdvertisement pipeAdvertisement) 
  {
	name = pipeAdvertisement.getName();
	id = pipeAdvertisement.getPipeID().getURL();
	type = pipeAdvertisement.getType();
  }
  
  /**
  * This method will return the pipe adv from which the NestId instance has been derived
  */
  public PipeAdvertisement getPipeAdv()
  {
	PipeAdvertisement pipeAdv = (PipeAdvertisement) AdvertisementFactory.newAdvertisement(PipeAdvertisement.getAdvertisementType());
	pipeAdv.setName( name );
	try
	{
	  pipeAdv.setPipeID( IDFactory.fromURL(id) );
	}
	catch(MalformedURLException mue)
	{
	  mue.printStackTrace();
	}
	catch(UnknownServiceException use)
	{
	  use.printStackTrace();
	}
	pipeAdv.setType( type );
	
	return pipeAdv;
  }
  
  /**
  * This method will return a string rapresentation of the NestId instance
  */
  public String toString()
  {
	//ID pipeID = pipeAdv.getPipeID();
	//String val = pipeID.toString();
	String val = null;
	try
	{
	  val = IDFactory.fromURL( id ).toString();
	}
	catch(MalformedURLException mue)
	{
	  mue.printStackTrace();
	}
	catch(UnknownServiceException use)
	{
	  use.printStackTrace();
	}
	return val; 
  }
  
  /**
  *  This method returns the pipe identifier URL representation
  */
  public URL getURL()
  {
  	return id;
  }
  
  /**
  * This method tests wether the <code>NestId</code> named <code>id</code> is equal
  * to the current instance or not.
  */
  public boolean equals(NestId id)
  {
  	jxtaimpl.ids.NestId jId = (jxtaimpl.ids.NestId)id;
	return this.getURL().equals( jId.getURL() );
	//return this.toString().trim().toLowerCase().equals(jId.toString().trim().toLowerCase());
  }
}
