/******************************************************
 * File: Query.java
 * created 17-Jan-02 12:06:29 PM by frusso@cs.unibo.it
 */

package jxtaimpl.storage;

import java.io.Serializable;

/**
 * This class has to be used by Ants in order to properly query CmsStorages
 * @author Francesco Russo (frusso@cs.unibo.it) 
 */
public class Query implements Serializable
{
  /**
  * The constructor needs an element name, and a set of possible values.
  * All these values are keywords separated by at least one blank space, 
  * all contained in one <CODE>String</CODE>
  *
  * @param element The element which has to be tested
  * @param values The set of values the element should be checked to contain
  */
  public Query(String element, String values)
  {
	elName = element;
	this.values = values;
  }
  
  /**
  * Returns the element name this query refers to.
  */
  public String getElementName()
  {
	return elName;
  }
  
  /**
  * Resturns a String containing all the keywords to be searched
  */
  public String getValues()
  {
	return this.values;
  }
  
  private String elName;
  private String values;
}
